# TODO
# - separate subpackages for C extension and FFI extension?
# - package bench as subpackage?
#
# Conditional build:
%bcond_with	tests		# build without tests

%define	pkgname	ffi-yajl
Summary:	Ruby FFI wrapper around YAJL 2.x
Name:		ruby-%{pkgname}
Version:	2.3.1
Release:	4
License:	Apache v2.0
Group:		Development/Languages
Source0:	http://rubygems.org/downloads/%{pkgname}-%{version}.gem
# Source0-md5:	3d3e3302e437d801d7c44262f568d7b9
Patch0:		system-yajl.patch
URL:		https://github.com/chef/ffi-yajl
BuildRequires:	rpm-rubyprov
BuildRequires:	rpmbuild(macros) >= 1.656
BuildRequires:	ruby-devel
BuildRequires:	ruby-rubygems
BuildRequires:	sed >= 4.0
BuildRequires:	yajl-devel >= 2.0
%if %{with tests}
BuildRequires:	ruby-ffi >= 1.5
BuildRequires:	ruby-pry >= 0.9
BuildRequires:	ruby-rack >= 2.0
BuildRequires:	ruby-rake >= 10.1
BuildRequires:	ruby-rake-compiler >= 1.0
BuildRequires:	ruby-rspec >= 3.0
%endif
Requires:	ruby-ffi >= 1.5
# libyajl.so.2 opened by FFI
Requires:	yajl < 3
Requires:	yajl >= 2.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Ruby FFI wrapper around YAJL 2.x

%prep
%setup -q -n %{pkgname}-%{version}
%patch0 -p1
%{__sed} -i -e '1 s,#!.*ruby,#!%{__ruby},' bin/*

%build
# write .gemspec
%__gem_helper spec

# provided by rpm deps
%{__sed} -i -e '/libyajl2/d' %{pkgname}-%{version}.gemspec

cd ext/ffi_yajl/ext/encoder
%{__ruby} extconf.rb
%{__make} V=1 \
	CC="%{__cc}" \
	LDFLAGS="%{rpmldflags}" \
	CFLAGS="%{rpmcflags} -fPIC"

cd ../parser
%{__ruby} extconf.rb
%{__make} V=1 \
	CC="%{__cc}" \
	LDFLAGS="%{rpmldflags}" \
	CFLAGS="%{rpmcflags} -fPIC"

cd ../dlopen
%{__ruby} extconf.rb
%{__make} V=1 \
	CC="%{__cc}" \
	LDFLAGS="%{rpmldflags}" \
	CFLAGS="%{rpmcflags} -fPIC"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{ruby_vendorlibdir},%{ruby_specdir},%{_bindir}}
cp -a lib/* $RPM_BUILD_ROOT%{ruby_vendorlibdir}
cp -a bin/* $RPM_BUILD_ROOT%{_bindir}
cp -p %{pkgname}-%{version}.gemspec $RPM_BUILD_ROOT%{ruby_specdir}

install -d $RPM_BUILD_ROOT%{ruby_vendorarchdir}/ffi_yajl/ext/{encoder,parser}
install -p ext/ffi_yajl/ext/parser/parser.so $RPM_BUILD_ROOT%{ruby_vendorarchdir}/ffi_yajl/ext
install -p ext/ffi_yajl/ext/encoder/encoder.so $RPM_BUILD_ROOT%{ruby_vendorarchdir}/ffi_yajl/ext
install -p ext/ffi_yajl/ext/dlopen/dlopen.so $RPM_BUILD_ROOT%{ruby_vendorarchdir}/ffi_yajl/ext

%{__rm} $RPM_BUILD_ROOT%{ruby_vendorlibdir}/ffi_yajl/benchmark.rb
%{__rm} -r $RPM_BUILD_ROOT%{ruby_vendorlibdir}/ffi_yajl/benchmark
%{__rm} $RPM_BUILD_ROOT%{_bindir}/ffi-yajl-bench
%{__rm} $RPM_BUILD_ROOT%{ruby_vendorlibdir}/ffi_yajl/ext/.keep

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%{ruby_vendorlibdir}/ffi_yajl.rb
%dir %{ruby_vendorlibdir}/ffi_yajl
%{ruby_vendorlibdir}/ffi_yajl/encoder.rb
%{ruby_vendorlibdir}/ffi_yajl/ext.rb
%{ruby_vendorlibdir}/ffi_yajl/ffi.rb
%{ruby_vendorlibdir}/ffi_yajl/map_library_name.rb
%{ruby_vendorlibdir}/ffi_yajl/parser.rb
%{ruby_vendorlibdir}/ffi_yajl/platform.rb
%{ruby_vendorlibdir}/ffi_yajl/version.rb
%dir %{ruby_vendorlibdir}/ffi_yajl/ffi
%{ruby_vendorlibdir}/ffi_yajl/ffi/encoder.rb
%{ruby_vendorlibdir}/ffi_yajl/ffi/parser.rb
%{ruby_specdir}/%{pkgname}-%{version}.gemspec

# ext
%dir %{ruby_vendorarchdir}/ffi_yajl
%dir %{ruby_vendorarchdir}/ffi_yajl/ext
%dir %{ruby_vendorarchdir}/ffi_yajl/ext/encoder
%dir %{ruby_vendorarchdir}/ffi_yajl/ext/parser
%attr(755,root,root) %{ruby_vendorarchdir}/ffi_yajl/ext/parser.so
%attr(755,root,root) %{ruby_vendorarchdir}/ffi_yajl/ext/encoder.so
%attr(755,root,root) %{ruby_vendorarchdir}/ffi_yajl/ext/dlopen.so
%changelog
* Sat Mar 21 2020 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ruby-ffi-yajl.git;a=log;h=master

* Sat Mar 21 2020 Jan Rękorajski <baggins@pld-linux.org> 7a00be9
- release 4 (by relup.sh)

* Sun Jul 15 2018 Jan Rękorajski <baggins@pld-linux.org> c57751f
- fixed system-yajl patch
- rel 3

* Sun Jul 15 2018 Jan Rękorajski <baggins@pld-linux.org> 5ee077e
- release 2 (by relup.sh)

* Sat Oct 28 2017 Elan Ruusamäe <glen@delfi.ee> 687eafe
- rebuild with fixed ruby(abi)
- release 3 (by relup.sh)

* Mon Oct 23 2017 Jan Rękorajski <baggins@pld-linux.org> 3949a10
- release 2 (by relup.sh)

* Mon Apr 17 2017 Jan Rękorajski <baggins@pld-linux.org> 8fec820
- rel 1

* Thu Jun 02 2016 Elan Ruusamäe <glen@delfi.ee> 1db908a
- fix library loading

* Thu Jun 02 2016 Elan Ruusamäe <glen@delfi.ee> f67f4bf
- build and package ext/dlopen.so

* Thu Jun 02 2016 Elan Ruusamäe <glen@delfi.ee> 07684df
- up to 2.2.3

* Sat Mar 19 2016 Elan Ruusamäe <glen@delfi.ee> 838657b
- ruby 2.1 rebuild
- release 3 (by relup.sh)

* Sun Mar 01 2015 Elan Ruusamäe <glen@delfi.ee> 95f62f4
- x32 rebuild
- release 2 (by relup.sh)

* Thu Jan 22 2015 Elan Ruusamäe <glen@delfi.ee> 107c18a
- BR deps

* Thu Jan 22 2015 Elan Ruusamäe <glen@delfi.ee> 18f8d1e
- ffi_yajl/ext: use hardcoded libyajl.so name

* Thu Jan 22 2015 Elan Ruusamäe <glen@delfi.ee> d8282a4
- package ext files where they are expected to be

* Thu Jan 22 2015 Elan Ruusamäe <glen@delfi.ee> 128412b
- up to 1.3.1

* Thu Jan 22 2015 Elan Ruusamäe <glen@delfi.ee> 183978c
- up to 1.3.0

* Mon Dec 22 2014 Elan Ruusamäe <glen@delfi.ee> fd40959
- avoid libyajl2 dep

* Mon Dec 22 2014 Elan Ruusamäe <glen@delfi.ee> 3572035
- rebuild with gemspec provides

* Fri Nov 14 2014 Elan Ruusamäe <glen@delfi.ee> 5b4c213
- rel 1

* Wed Nov 12 2014 Elan Ruusamäe <glen@delfi.ee> c06241f
- skip ruby-libyajl2 hack also during build

